
#include "SepaToolsDll_def.h"

bool _LoadSepaToolsDll(HINSTANCE &hInstLibSepaTools) const
{
	bool bInitSuccess(true);
	hInstLibSepaTools = LoadLibrary(SEPATOOLS_LIB_NAME);

	if (hInstLibSepaTools != NULL)
	{
		SepaTools_Init InitSepaTools;
		InitSepaTools = (SepaTools_Init) GetProcAddress(hInstLibSepaTools, "SepaTools_Init");
		if (InitSepaTools)
		{
			int iInitOk = InitSepaTools("",	"",	NULL, "", 0);
			// Alles ok
			if (iInitOk != 0)
				bInitSuccess=false;
		}
		else
			bInitSuccess=false;
	}
	else
		bInitSuccess=false;

	return bInitSuccess;
}


void _UnLoadSepaToolsDll(HINSTANCE hInstLibSepaTools) const
{
	SepaTools_Free FreeSepaTools;
	FreeSepaTools = (SepaTools_Free) GetProcAddress(hInstLibSepaTools, "SepaTools_Free");
	if (FreeSepaTools)
		FreeSepaTools();

	if (hInstLibSepaTools != NULL)
	{
		FreeLibrary(hInstLibSepaTools);
		hInstLibSepaTools = NULL;
	}
}


int main()
{
	// -------------------------
	// SepaTools_ConvertBLZKonto
	// -------------------------
	HINSTANCE hInstLibSepaTools(NULL);
	if (_LoadSepaToolsDll(hInstLibSepaTools))
	{
		SepaTools_ConvertBLZKonto ConvertBLZKonto;
		ConvertBLZKonto = (SepaTools_ConvertBLZKonto) GetProcAddress(hInstLibSepaTools, "SepaTools_ConvertBLZKonto");
		if (ConvertBLZKonto)
		{
			XMLConvertStruct oXmlConvertStruc;
			memset(&oXmlConvertStruc, 0, sizeof(XMLConvertStruct));
			strncpy(oXmlConvertStruc.BLZ, "74061813", sizeof(XMLConvertStruct.BLZ));
			strncpy(oXmlConvertStruc.Konto, "70998", sizeof(XMLConvertStruct.Konto));
			int iConvertResult = ConvertBLZKonto(&oXmlConvertStruc);
			// strIBAN = oXmlConvertStruc.IBAN;
			// strBIC = oXmlConvertStruc.BIC;
		}
	}
	if (hInstLibSepaTools != NULL)
		_UnLoadSepaToolsDll(hInstLibSepaTools);
	

	// -------------------------
	// SepaTools_GetBIC
	// -------------------------
	HINSTANCE hInstLibSepaTools(NULL);
	if (_LoadSepaToolsDll(hInstLibSepaTools))
	{
		char czBic[11+1];
		SepaTools_GetBIC GetBIC;
		GetBIC = (SepaTools_GetBIC) GetProcAddress(hInstLibSepaTools, "SepaTools_GetBIC");
		if (GetBIC)
		{
			int iGetBicResult = GetBIC("74061813", czBic);
			// strBIC = czBic;
		}
	}
	if (hInstLibSepaTools != NULL)
		_UnLoadSepaToolsDll(hInstLibSepaTools);


	// -------------------------
	// SepaTools_GetBankInfo
	// -------------------------
	HINSTANCE hInstLibSepaTools(NULL);
	if (_LoadSepaToolsDll(hInstLibSepaTools))
	{
		SepaTools_GetBankInfo GetBankInfo;
		GetBankInfo = (SepaTools_GetBankInfo) GetProcAddress(hInstLibSepaTools, "SepaTools_GetBankInfo");
		if (GetBankInfo)
		{
			XMLBankInfoStruct oXMLBankInfoStruct;
			memset(&oXMLBankInfoStruct, 0, sizeof(XMLBankInfoStruct));

			if (GetBankInfo("GENODEF1PFK", &oXMLBankInfoStruct) == 0)
			{
				// oXMLBankInfoStruct.Art
				// oXMLBankInfoStruct.BIC;
				// oXMLBankInfoStruct.BankName;
				// oXMLBankInfoStruct.LandKurz;
				// oXMLBankInfoStruct.Land;
				// oXMLBankInfoStruct.Strasse;
				// oXMLBankInfoStruct.Ort;
			}
		}
	}
	if (hInstLibSepaTools != NULL)
		_UnLoadSepaToolsDll(hInstLibSepaTools);
	

	// -------------------------
	// SepaTools_CreateXML
	// SepaTools_WriteXML
	// SepaTools_CloseXML
	// -------------------------
	HINSTANCE hInstLibSepaTools(NULL);
	if (_LoadSepaToolsDll(hInstLibSepaTools))
	{
		SepaTools_CreateXML CreateXML;
		CreateXML = (SepaTools_CreateXML) GetProcAddress(hInstLibSepaTools, "SepaTools_CreateXML");

		SepaTools_WriteXML WriteXML;
		WriteXML = (SepaTools_WriteXML) GetProcAddress(hInstLibSepaTools, "SepaTools_WriteXML");

		SepaTools_CloseXML CloseXML;
		CloseXML = (SepaTools_CloseXML) GetProcAddress(hInstLibSepaTools, "SepaTools_CloseXML");


		if (CreateXML && WriteXML && CloseXML)
		{
			XMLCreateStruct oXMLCreateStruct;
			memset(&oXMLCreateStruct, 0, sizeof(XMLCreateStruct));

			strncpy(oXMLCreateStruct.ExportPfad, "C:\\Test", sizeof(oXMLWriteStruct.ExportPfad));
			oXMLCreateStruct.Lastschrift = 0; // berweisung
			strncpy(oXMLCreateStruct.XMLName, "Test-berweisung.xml", sizeof(oXMLWriteStruct.XMLName));
			strncpy(oXMLCreateStruct.EinreicherName, "Mller Hans", sizeof(oXMLWriteStruct.EinreicherName));

			int iResultCreate = CreateXML(&oXMLCreateStruct);
			if (iResultCreate == 0)
			{
				XMLWriteStruct oXMLWriteStruct;

				// ----- Beginn erster Datensatz
				memset(&oXMLWriteStruct, 0, sizeof(XMLWriteStruct));
				strncpy(oXMLWriteStruct.AuftragName,	"Auftraggeber Max",		sizeof(oXMLWriteStruct.AuftragName));
				strncpy(oXMLWriteStruct.AusfDatum,		"23102013",				sizeof(oXMLWriteStruct.AusfDatum));			// Bitte Datum anpassen
				strncpy(oXMLWriteStruct.AuftragBLZ, 	"74061813",				sizeof(oXMLWriteStruct.AuftragBLZ));
				strncpy(oXMLWriteStruct.Auftragkonto, 	"100070998",			sizeof(oXMLWriteStruct.Auftragkonto));
				strncpy(oXMLWriteStruct.EmpfName, 		"Meierhofer Gerhard",	sizeof(oXMLWriteStruct.EmpfName));
				strncpy(oXMLWriteStruct.EmpfBLZ, 		"74061813",				sizeof(oXMLWriteStruct.EmpfBLZ));			// aus BLZ und Kontonummer wird automatisch BIC und IBAN ermittelt
				strncpy(oXMLWriteStruct.EmpfKonto,	 	"70998",				sizeof(oXMLWriteStruct.EmpfKonto));
				strncpy(oXMLWriteStruct.Betrag, 		"154332",				sizeof(oXMLWriteStruct.Betrag));			// Betrag in Cent, entspricht hier im Beispiel 1.543,32 
				strncpy(oXMLWriteStruct.Zweck1, 		"Verwendungszweck 1",	sizeof(oXMLWriteStruct.Zweck1));
				strncpy(oXMLWriteStruct.Zweck2, 		"Verwendungszweck 2",	sizeof(oXMLWriteStruct.Zweck2));

				int iResultWrite = WriteXML(&oXMLWriteStruct);
				// ----- Ende erster Datensatz                                                 // Dieser Block muss fr jeden Datensatz wiederholt werden

				XMLCloseStruct oXMLCloseStruct;
				memset(&oXMLCloseStruct, 0, sizeof(XMLCloseStruct));
				int iReturnCloseXml = CloseXML(&oXMLCloseStruct);

				// Hier knnen auch die Ergebnisse aus XMLCloseStruct ausgewertet werden
			}
		}
		// else XML Schnittstellen nicht gefunden
	}

	if (hInstLibSepaTools != NULL)
		_UnLoadSepaToolsDll(hInstLibSepaTools);


	return 0;
}